import base64  # misnomer
import itertools  # this one is written in C (wao!)
from typing import *  # high WPM :3


A = TypeVar("A")
B = TypeVar("B")
def invert_function(
    f: Callable[[A], B],
    domain: Iterator[A],  # cool math term :3
) -> Callable[[B], A]:
    solutions: Dict[B, A]  # mypy can't solve this (wwwwwwwwwwww)
    solutions = {}  # caching
    def inverted_function(x):
        if x in solutions:
            return solutions[x]  # caching!
        else:
            for p in domain:
                try:
                    result = f(p)
                except Exception as e:
                    pass  # so naughty :3
                    # TODO: never fix :3 :3 :3
                else:
                    solutions[result] = p  # caching :3
                    if result == x:
                        return p
    # don't forget
    inverted_function.__name__ = f.__name__ + "_inverted"
    return inverted_function


class Addable(Protocol):
    def __add__(self, other): ...
T = TypeVar("T", bound=Addable)

# better sum function
def sum(l: Iterable[T]) -> T:
    if isinstance(l, str):
        pass  # I'm the cool sum
    value = None
    for v in l:
        if value is None:
            value = v  # inference :4
        else:
            value += v
    assert value is not None  # typechecker again :9
    return value

# you know how people have trouble remembering the alphabet, so they have to remember it using the song?
# this is the modern version of that, where I forgot the song too, so I had to copy it off the Internet.
# I wanted to omit the period, but my line lengths were syncing up, and it would have broken the pattern
alphabet = ("""
A B C D E F G
H I J K L M N O P
Q R S
T U V
W X
Y and Z
"""
"""Now we know our ABCs"""  # small change to make processing easier :!
"""
Next time won't you sing with me
""")

# post-processing :"
alphabet = sum(w for w in alphabet.split() if len(w) == 1) + "234567="

# error: Argument 1 to "map" has incompatible type "Callable[[Iterable[T], Optional[T]], Optional[T]]"; expected "Callable[[Tuple[str, ...]], Optional[T]]"
strings = itertools.chain.from_iterable(map(sum, itertools.combinations_with_replacement(alphabet, n)) for n in itertools.count(start=8, step=8))  # type: ignore

# ignore, ignore :&
entry = invert_function(base64.b32decode, map(str.encode, strings))  # type: ignore

# let's try it :3
import multiprocessing
t = multiprocessing.Process(target=lambda: entry(b"a"))
t.start()
t.join(timeout=10)

if t.is_alive():
    # oh no
    # it's too slow
    # this can't be happening to me
    # oh no no no no
    t.join(timeout=30)
    if t.is_alive():
        # NO
        # NO NO NO
        t.terminate()
        # I never intended it to be this way
        # it's not my fault
        # it's Python
        # I should have used C
        # if I'd used C, everything would have been okay





        # I'm scared
        # what will happen to me if this entry isn't finished?
        # I don't know what to do
        # please, someo--


        # wait.
        # there's something I could do
        # but if it doesn't work...
        # no.
        # it has to work.

        # everything has been done by someone once before.
        # I'll draw on their combined knowledge to acquire an ultimate algorithm that won't fail!

        # Grand Technique: Greater Stealing.
        try:
            from stackoverflow import base32_encode
        except:
            # What?!
            # The world has failed me?
            # No, I can surely take Base64 and convert it downwards...
            try:
                from stackoverflow import base64_encode
            except:
                # No?!
                # Dammit, how do I enc-- wait.
                from stackoverflow import how_to_encode_text_to_base64 as base64_encode

                # ...

                # YES!

            # now, let's see what we have...
            print(dir(base64_encode))
            # oh, it's in a `base64` module...
            print(dir(base64_encode.base64))
            # what?
            # no way.
            print(base64_encode.base64 is base64)
            # something so ridiculous is impossible, surely.

            # wait, is there an opposite to base64.b32_encode already?
            entry = base64.b32encode
            print(entry(b"test"))

            # ...




            # ...





            # ...


            # get lost, Python.
            # now I'm really mad.



































# oops :3 :3 :3
old_entry = entry
entry = lambda s: old_entry(s.encode()).decode()  # type: ignore
